<?php

/* *** <head>~</head> 안에 본문에 넣을 단추의 CSS를 끼워넣는다. *** */
function header_content($target) {

	global $configVal, $entry, $pageTitle;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) init_config($data);
	
	$context = Model_Context::getInstance();
	$blog_id = $context->getProperty('blog.id');
	$blogURL = $context->getProperty('uri.blog');
	$title = $context->getProperty('blog.title');

	if($data['beginning_length']) $beginning_length = $data['beginning_length'];
	else $beginning_length = 150;
	$beginning = UTF8::lessenAsEm(removeAllTags(stripHTML($entry['content'])), $beginning_length);
	
	$header = "";
	if($data['meta_title'] && !empty($title)) $header .= '<meta name="title" content="'.$title.'" />'.CRLF;
	if($data['meta_description'] && !empty($beginning)) $header .= '<meta name="Description" content="'.$beginning.'" />'.CRLF;
	if($data['image_src']) {		// 글에 붙인 그림 하나를 미리보기 그림(thumbnail)로 알린다.
		if(preg_match("/\[##_(1R|1L|1C|2C|3C|iMazing|Gallery)\|([^|]*)\.(gif|jpg|jpeg|png|bmp)\|.*_##\]/i", $entry['content'], $matches))
			$header .= '<link rel="image_src" href="'.$blogURL."/attach/".$blog_id."/".$matches[2].".".$matches[3].'" />'.CRLF;
		else if(preg_match("/\<img[^>]+?src=(\"(.*?)\"|'(.*?)').*\>/i",  $entry['content'], $matches)) 
			$header .= '<link rel="image_src" href="'.$matches[2].'" />'.CRLF;
	}
	$header .= CRLF."<style type=\"text/css\">".CRLF;
	$position_array = array("onTop", "onBottom", "onSidebar", "onTag", "account_icons_onTag", "account_icons_onSidebar");

	foreach($position_array as $position) {
		if($data[$position.'_css'] && ($data[$position] || substr($position,-7,7)=="Sidebar" || substr($position,-3,3)=="Tag")) $header .= stylesheet($position).CRLF;
	}
	$header .= "</style>".CRLF;

	return $target.$header;
}

/* *** 위치에 맞추어 단추의 CSS 내용을 돌려 준다. *** */
function stylesheet($position) {

	global $pluginURL, $configVal;
	$data = Setting::fetchConfigVal($configVal);
	
	if(is_null($data)) init_config($data);

	$type = $data[$position.'_type'];		// 단추 모양
	$align = $data[$position.'_align'];		// 가로 정렬
	$icon_type = $data[$position.'_type'] == "text" ? $icon_type = "button" : $icon_type = "span";
			
	preg_match("/(?P<size>\d+)($|(?P<unit>\w+))/", $data[$position.'_margin_top'], $margin_top);		// 여백의 크기와 단위를 뽑는다.
	preg_match("/(?P<size>\d+)($|(?P<unit>\w+))/", $data[$position.'_margin_bottom'], $margin_bottom);
	preg_match("/(?P<size>\d+)($|(?P<unit>\w+))/", $data[$position.'_margin_left'], $margin_left);
	preg_match("/(?P<size>\d+)($|(?P<unit>\w+))/", $data[$position.'_margin_right'], $margin_right);
	preg_match("/(?P<size>\d+)($|(?P<unit>\w+))/", $data[$position.'_icon_interval'], $icon_interval);
	preg_match("/(?P<size>\d+)($|(?P<unit>\w+))/", $data[$position.'_icon_line_height'], $icon_line_height);
	preg_match("/(?P<size>\d+)($|(?P<unit>\w+))/", $data[$position.'_sidename_width'], $icon_sidename_width);
	
	if(empty($margin_top['unit'])) $margin_top['unit'] = "px";
	if(empty($margin_bottom['unit'])) $margin_bottom['unit'] = "px";
	if(empty($margin_left['unit'])) $margin_left['unit'] = "px";
	if(empty($margin_right['unit'])) $margin_right['unit'] = "px";
	if(empty($icon_interval['unit'])) $icon_interval['unit'] = "px";
	if(empty($icon_line_height['unit'])) $icon_line_height['unit'] = "px";
	if(empty($icon_sidename_width['unit'])) $icon_sidename_width['unit'] = "px";
	
	if(empty($margin_top['size'])) $margin_top['size'] = "0";
	if(empty($margin_bottom['size'])) $imargin_bottom['size'] = "0";
	if(empty($margin_left['size'])) $margin_left['size'] = "0";
	if(empty($margin_right['size'])) $margin_right['size'] = "0";
	if(empty($icon_interval['size'])) $icon_interval['unit'] = "0";
	if(empty($icon_line_height['size'])) $icon_line_height['unit'] = "0";
	if(empty($icon_sidename_width['size'])) $icon_sidename_width['unit'] = "0";

	if($align=="right") { $icon_margin_left = $icon_interval['size']; $icon_margin_right = 0;}		// 가로 정렬 방식에 맞게 단추 간격을 정한다.
	else if($align=="left") {$icon_margin_right = $icon_interval['size']; $icon_margin_left = 0;}
	else {
			$icon_margin_left = (int)($icon_interval['size']/2);
			$icon_margin_right = (int)($icon_interval['size']/2) + $icon_interval['size']%2;
	}
	
	if(substr($position,0,2)=="on") $position_class = ".SNS_icons_".$position; 	// 글 보내기 단추를 넣을 때
	else $position_class .= ".SNS_".$position;		// 계정 단추를 넣을 때
	
	$header .= $position_class." {";
	if($align != "none") $header .= "text-align:".$align.";";
	$header .= "margin:".$margin_top['size'].$margin_top['unit']." ".$margin_right['size'].$margin_right['unit']." ".$margin_bottom['size'].$margin_bottom['unit']." ".$margin_left['size'].$margin_left['unit'].";";
	$header .= "}";

	preg_match("/(?P<width>\d+)x(?P<height>\d+)/", $type, $icon_size);

	$header .= $position_class." .icon_wrap {";
	$header .= "cursor:pointer;";
	if($icon_margin_left) $header .= "margin-left:".$icon_margin_left.$icon_interval['unit'].";";
	if($icon_margin_right) $header .= "margin-right:".$icon_margin_right.$icon_interval['unit'].";";
	$header .= "}";
	
	if($type == "text") {
		$header .= $position_class." .icon_wrap {";
		$header .= "display:inline;";
		$header .= "}";
		$header .= $position_class." .icon_wrap ".$icon_type." {";
		$header .= "display:inline;";
		if($icon_line_height['size']) $header .= "margin-bottom:".$icon_line_height['size'].$icon_line_height['unit']." !important;";		
		$header .= "}";
	}

	if($type != "text") {
		$header .= $position_class." .icon_wrap {";
		if($data[$position.'_sidename_position'] == "bottom") {
			$header .= "display:inline-block;";
			$header .= "vertical-align:top;";
			$header .= "text-align:center;";
			if($icon_line_height['size']) $header .= "margin-bottom:".$icon_line_height['size'].$icon_line_height['unit']." !important;";
		} else {
			$header .= "width:".$icon_size['width']."px;";
			$header .= "display:inline;";
		}		
		$header .= "}";
		
		$header .= $position_class." .icon_wrap ".$icon_type." {";
		$header .= "border:0;";
		$header .= "cursor:pointer;";
		if($data[$position.'_sidename_position'] == "bottom") {
			$header .= "display:block;";
			$header .= "margin-left:auto;";
			$header .= "margin-right:auto;";
		}	else {
			$header .= "display:inline-block;";
			if($icon_line_height['size']) $header .= "margin-bottom:".$icon_line_height['size'].$icon_line_height['unit']." !important;";
		}
		
		$header .= "width:".$icon_size['width']."px;";
		$header .= "height:".$icon_size['height']."px;";
		$header .= "background:url('".($data['icon_path'] ? $data['icon_path'] : $pluginURL."/images")."/sns_icons_".$icon_size['width']."x".$icon_size['height'].".png');";
		$header .= "}";

		if($data[$position.'_sidename_position'] != "none" || !$data[$position.'_sidename_position']) {			// 쪽그림에 이름을 붙일 때
			$header .= $position_class." span.sidename {";
			$header .= "cursor:pointer;";
			$header .= "text-align:center;";		
			$header .= "font:".$data[$position.'_sidename_font_size']."px dotum;";
			if($data[$position.'_sidename_font_color']) $header .= "color:#".$data[$position.'_sidename_font_color'].";";
			$header .= "background:none!important;";
			if($icon_sidename_width['size']) $header .= "width:".$icon_sidename_width['size'].$icon_sidename_width['unit']."!important;";
			else $header .= "width:auto!important;";

			if($data[$position.'_sidename_position'] == "bottom") {
				$header .= "height:auto !important;";
				$header .= "margin-top:".$data[$position.'_sidename_margin']."px;";
			} else {
				$header .= "display:inline-block;";
				$header .= "margin-top:".round(($icon_size['height']-$data[$position.'_sidename_font_size'])/2)."px;";
				$header .= "margin-left:".($data[$position.'_sidename_margin'])."px;";
				$header .= "vertical-align:top;";
				$header .= "text-align:left;";
			}
			$header .= "}";
		}
		
		if(strpos($_SERVER['HTTP_USER_AGENT'], "MSIE")) {
			preg_match("/MSIE (?P<version>\d+)/", $_SERVER['HTTP_USER_AGENT'], $browser);
			if($browser['version'] < 8) {		// IE 7 이하일 때
				$header .= $position_class." .icon_wrap {";
				if($data[$position.'_sidename_position'] == "bottom") {
					if($icon_sidename_width['size'] > $icon_size['width']) $header .= "width:".$icon_sidename_width['size'].$icon_sidename_width['unit']." !important;";
					else $header .= "width:".$icon_size['width']."px;";
				} else $header .= "width:auto;";
				$header .= "display:inline;";
				$header .= "}";
			}
		}
	
		SNS_names($sns_name_array, $sns_balloon_name_array, $sns_sidename_array);
		$i = 0;
		foreach($sns_name_array as $sns_name) {
			if(($data[$position."_".$sns_name] && substr($position,0,7) != "account") || ($data[$sns_name.'_id'] && substr($position,0,7) == "account")) {
				$header .= $position_class." .icon_wrap .".$sns_name." {";
				$header .= "background-position:".(-($i)*$icon_size['width'])."px 0;";				
				$header .= "}";
			}
			++$i;
		}
	}
	
	return $header;
}

/* *** 위치에 맞게 글 보내는 단추의 HTML 내용을 돌려 준다. *** */
function show_icons($position, $entry_id) {

	global $blog, $configVal, $pluginURL;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) init_config($data);			// 설정값이 없으면 기본값을 넣는다.

	$context = Model_Context::getInstance();
	$defaultURL = $context->getProperty('uri.default');
	$blog_id = $context->getProperty('blog.id');
	$useEncodeURL = $context->getProperty('service.useEncodeURL');
	
	$DB_data = DBModel::getInstance();
	$DB_data->reset('Entries');
	$DB_data->setQualifier('blogid','eq',$blog_id);
	$DB_data->setQualifier('id','eq',$entry_id);
	$entry = $DB_data->getRow();
	
	if($entry['id']) $original_url = $defaultURL."/".($blog['useSloganOnPost'] && $data['post_url']==1 ? "entry/".URL::encode($entry['slogan'], $useEncodeURL) : $entry['id']);		// 글 주소
	else $original_url = "http://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
	$encoded_original_url = rawurlencode($original_url);

	if($data['short_url'] == "other" && !empty($data['other_url'])) {
		if($entry['id']) $url = $data['other_url'].(substr($data['other_url'],-1,1)=="/" ? "" : "/").($blog['useSloganOnPost'] && $data['post_url']==1 ? "entry/".URL::encode($entry['slogan'], $useEncodeURL) : $entry['id']);		// 글 주소
		else $url = $data['other_url'].(substr($data['other_url'],-1,1)=="/" ? "" : "/").$_SERVER['REQUEST_URI'];
	} else $url = $original_url;

	$encoded_url = rawurlencode($url);

	$title = $entry['title'];
	$encoded_title = rawurlencode($title);

	if($data['beginning_length']) $beginning_length = $data['beginning_length'];
	else $beginning_length = 150;

	// 본문에 이 확장기능이 쓰는 치환자가 들었지는 확인하여 글이 나오지 않는 오류를 막는다.
	if(strpos($entry['content'],"[##_SNS_icons_##]") || strpos($entry['content'],"[##_SNS_account_icons_##]"))
		$text = htmlspecialchars(UTF8::lessenAsEm((stripHTML($entry['content'])), $beginning_length));	
	else $text = htmlspecialchars(UTF8::lessenAsEm(removeAllTags(stripHTML($entry['content'])), $beginning_length));

	$encoded_text = rawurlencode($text);
	
	$tags_array = getTags($blog_id, $entry['id']);		// 글의 꼬리표를 따온다.
	foreach($tags_array as $tag) $tags .= $tag['name'].",";
	if(substr($tags,-1) == ",") $tags = substr($tags,0,-1);
	$encoded_tags = rawurlencode($tags);

	switch($data['twitter_link']) {			// 선택값에 따라 트위터에 넣을 글 주소(고유주소/단축주소)를 정한다.
		case 1:		// 블로그 고유 주소 쓰기
			$link['twitter'] = "twitter.com/?status=".$encoded_title.rawurlencode(" ").$encoded_url;
			if($data['twitter_id'] && $data['twitter_via']) $link['twitter'] .= rawurlencode(" via @".$data['twitter_id']);
			break;
		case 2;		// 자체 주소(t.co) 쓰기
			if($entry['id']) $encoded_url_in_twitter = rawurlencode($defaultURL."/".$entry['id']);		// 블로그 숫자 주소로 연결함
			else $encoded_url_in_twitter = $encoded_url;
			$link['twitter'] = "twitter.com/intent/tweet?text=".$encoded_title;
			$link['twitter'] .= "&amp;url=".$encoded_url_in_twitter;
			if($data['twitter_id']) $link['twitter'] .= "&amp;via=".$data['twitter_id'];
			break;
	}
	
	$link['facebook'] = "www.facebook.com/sharer.php?t=".$encoded_title."&amp;u=".$encoded_original_url;
	$link['me2day'] = "me2day.net/posts/new?new_post[body]=".$encoded_title.urlencode(" \"").$encoded_url.urlencode("\":").$encoded_url."&amp;new_post[tags]=".$encoded_tags;
	$link['yozm'] = "yozm.daum.net/home?m=".$encoded_title."%20".$encoded_url;
	//$link['yozm'] = "yozm.daum.net/api/popup/prePost?sourceid=41&amp;link=".$encoded_url."&amp;prefix=".$encoded_title."+".$encoded_url;
	$link['connect'] = "connect.nate.com/index.nate?msg=".$encoded_title."%20".$encoded_url;
	$link['c_empathy'] = "csp.cyworld.com/bi/bi_recommend_pop.php?url=".$encoded_original_url."&amp;t=".$encoded_title;
	$link['tumblr'] = "www.tumblr.com/share?v=3&amp;u=".$encoded_url."&amp;t=".$encoded_title;
	$link['digg'] = "digg.com/submit?phase=0&amp;url=".$encoded_original_url."&amp;title=".$encoded_title."&amp;bodytext=".$encoded_text;
	$link['google_bookmarks'] = "www.google.com/bookmarks/mark?op=add&amp;bkmk=".$encoded_original_url."&amp;title=".$encoded_title."&amp;annotation=".$encoded_text."&amp;labels=".$encoded_tags;
	$link['delicious'] = "www.delicious.com/save?v=5&amp;noui&amp;jump=close&amp;url=".$encoded_original_url."&amp;title=".$encoded_title; //."&amp;tags=".$encoded_tags;
	$link['yahoo_bookmarks'] = "bookmarks.yahoo.com/toolbar/savebm?opener=tb&amp;t=".$encoded_title."&amp;d=".$encoded_text."&amp;u=".$encoded_original_url;

	$icon_type = $data[$position.'_type'] == "text" ? $icon_type = "button" : $icon_type = "span";

	$header .= '<div class="SNS_icons_'.$position.'">';
	SNS_names($sns_name_array, $sns_balloon_name_array, $sns_sidename_array);

	foreach($sns_name_array as $sns_name) {
		if(!$data[$position.'_'.$sns_name] || !$link[$sns_name]) continue;
		$sns_balloon_name = $sns_balloon_name_array[$sns_name];
		$sns_sidename = $sns_sidename_array[$sns_name];
		$window_width = 780;
		$window_height = 510;
		if($sns_name == "twitter" || $sns_name == "me2day" || $sns_name == "connect") $window_width = 990;

		if($data['short_url'] != "none" && $data['short_url'] != "other" && preg_match("/^(twitter|me2day|yozm)/",$sns_name) && !($sns_name=="twitter" && $data['twitter_link'] == 2))
			$onclick = "window.open('".$pluginURL."/"."convert_to_shortURL.php?shortURL_domain=".$data['short_url']."&amp;linkURL=".urlencode($link[$sns_name])."&amp;longURL=".$encoded_url."&amp;width=".$window_width."&amp;height=".$window_height."', '".$sns_name."', 'width=".$window_width.", height=".$window_height.", resizable=1, scrollbars=1');";
		else $onclick = "window.open('http://".$link[$sns_name]."', '".$sns_name."', 'width=".$window_width.", height=".$window_height.", resizable=1, scrollbars=1');";

		$header .= '<div class="icon_wrap" title="'.$sns_balloon_name.'에 보내기" onclick="'.$onclick.'">';
		$header .= '<'.$icon_type.' class="'.$sns_name.'">';
		if($icon_type == "button") $header .= '<span>'.$sns_sidename.'</span>';
		$header .= '</'.$icon_type.'>';
		if($data[$position.'_sidename_position'] != "none" && $icon_type != "button") $header .= '<span class="sidename">'.$sns_sidename.'</span>';
		$header .= '</div>';
	}

	$header .= "</div>".CRLF;
 
	return CRLF.$header;
}

/* *** 위치에 맞게 계정으로 보내는 단추의 HTML 내용을 돌려 준다. *** */
function show_account_icons($position) {
	global $pageTitle, $configVal, $entry;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) init_config($data);			// 설정값이 없으면 기본값을 넣는다.

	if($data['twitter_id']) $link['twitter'] = "http://twitter.com/".$data['twitter_id'];
	if($data['facebook_id']) $link['facebook'] = "http://www.facebook.com/".$data['facebook_id'];
	if($data['me2day_id']) $link['me2day'] = "http://me2day.net/".$data['me2day_id'];
	if($data['yozm_id']) $link['yozm'] = "http://yozm.daum.net/".$data['yozm_id'];
	if($data['youtube_id']) $link['youtube'] = "http://www.youtube.com/".$data['youtube_id'];
	if($data['flicker_id']) $link['flicker'] = "http://www.flicker.com/".$data['flicker_id'];

	$icon_type = $data[$position.'_type'] == "text" ? $icon_type = "button" : $icon_type = "span";
	$header = '<div class="SNS_'.$position.'">';
	SNS_names($sns_name_array, $sns_balloon_name_array, $sns_sidename_array);

	foreach($sns_name_array as $sns_name) {
		if(!$data[$sns_name.'_id']) continue;
		$sns_balloon_name = $sns_balloon_name_array[$sns_name];
		$sns_sidename = $sns_sidename_array[$sns_name];
		$header .= '<div class="icon_wrap" title="'.$sns_balloon_name.' 계정"'.($icon_type=="button" ? ' onclick="window.open(\''.$link[$sns_name].'\',\''.$sns_name.'\');">' : '>');
		if($icon_type != "button") $header .= '<a href="'.$link[$sns_name].'" target="_blank">';
		$header .= '<'.$icon_type.' class="'.$sns_name.'">';
		$header .= $icon_type=="button" ? '<span>'.$sns_sidename.'</span>' : '';
		$header .= '</'.$icon_type.'>';
		if($data[$position.'_sidename_position'] != "none" && $icon_type != "button") $header .= '<span class="sidename">'.$sns_sidename.'</span>';
		if($icon_type != "button") $header .= '</a>';
		$header .= '</div>';
	}
	$header .= '</div>'.CRLF;

	return CRLF.$header;
}

/* ***	치환자 [##_SNS_icons_##]에 단추를 넣는다. *** */
function show_icons_onTag($target) {
	global $configVal;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) init_config($data);

	$position = "onTag";
	$tagContent = show_icons($position);

	return $tagContent;
}


/* ***	옆막대에 글 보내는 단추를 넣는다. *** */
function show_icons_onSidebar($parameter) {
	global $configVal;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) init_config($data);

	$position = "onSidebar";
	$sidebarContent .= show_icons($position);

	return $sidebarContent;
}


/* ***	본문에 글 보내기 단추를 넣는다. *** */
function show_icons_onContent($target, $mother) {
	global $configVal;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) init_config($data);

	$position_array = array("onTop", "onBottom");
	
	foreach($position_array as $position) 
		if($data[$position]) $header[$position] = show_icons($position, $mother);
	
	return $header['onTop'].$target.$header['onBottom'];
}


/* *** 옆막대에 계정으로 보내는 단추를 넣는다. *** */
function show_account_icons_onSidebar($parameter) {
	global $configVal;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) init_config($data);
	
	$position = "account_icons_onSidebar";
	
	$sidebarContent = "";
	if($data[$position.'_heading_tag'])
		$sidebarContent .= "<".$data[$position.'_heading_tag'].">".$data[$position.'_heading_title']."</".$data[$position.'_heading_tag'].">";
	$sidebarContent .= show_account_icons($position);
	
	return $sidebarContent;
}

function show_account_icons_onTag($parameter) {
	global $configVal;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) init_config($data);
	
	$position = "account_icons_onTag";
	$sidebarContent = show_account_icons($position);
	
	return $sidebarContent;
}

/* *** 환경설정값이 없으면 기본값으로 채운다. *** */
function init_config(&$data) {
	$data['beginning_length'] = 150;
	$data['short_url'] = "none";
	$data['other_url'] = "";
	$data['post_url'] = 1;
	$data['twitter_link'] = 1;

	$position_array = array("onTop", "onBottom", "onSidebar", "onTag", "account_icons_onTag", "account_icons_onSidebar");
	SNS_names($sns_name_array, $sns_balloon_name_array, $sns_sidename_array);

	foreach($position_array as $position) {
		$data[$position.'_css'] = 1;
		foreach($sns_name_array as $sns_name) $data[$position.'_'.$sns_name] = 1;
		$data[$position] = 0;
		$data[$position.'_type'] = "24x24";
		$data[$position.'_align'] = "right";
		$data[$position.'_icon_interval'] = "5";
		$data[$position.'_icon_line_height'] = "10";
		$data[$position.'_sidename_position'] = "none";
		$data[$position.'_sidename_font_size'] = "11";
		$data[$position.'_sidename_color'] = "";
		$data[$position.'_sidename_margin'] = "5";
		$data[$position.'_sidename_width'] = "0";
		$data[$position.'_margin_top'] = "10";
		$data[$position.'_margin_bottom'] = "10";
		$data[$position.'_margin_left'] = "0";
		$data[$position.'_margin_right'] = "0";
		if(substr($position,-7,7)=="Sidebar") {
			$data[$position.'_heading_tag'] = "";
			$data[$position.'_heading_title'] = "h3";
		}
	}

	$data['onBottom'] = 1;
}


/* *** SNS와 즐겨찾기 누리집의 이름을 넣는다. *** */
function SNS_names(&$sns_name_array, &$sns_balloon_name_array, &$sns_sidename_array){
	$sns_name_array = array("twitter", "facebook", "yozm", "me2day", "connect", "c_empathy", "tumblr", "digg", "google_bookmarks", "delicious", "yahoo_bookmarks", "youtube", "flicker");
	$sns_balloon_name_array = array('twitter'=>"트위터", 'facebook'=>"페이스북", 'yozm'=>"요즘", 'me2day'=>"미투데이", 'connect'=>"커넥트", 'c_empathy'=>"C공감", 'tumblr'=>"텀블", 'digg'=>"디그", 'google_bookmarks'=>"구글 즐겨찾기", 'delicious'=>"딜리셔스", 'yahoo_bookmarks'=>"야후 즐겨찾기", 'youtube'=>"유튜브" ,'flicker'=>"플리커");
	$sns_sidename_array = array('twitter'=>"트위터", 'facebook'=>"페이스북", 'yozm'=>"요즘", 'me2day'=>"미투데이", 'connect'=>"커넥트", 'c_empathy'=>"C공감", 'google_bookmarks'=>"구글", 'tumblr'=>"텀블", 'digg'=>"디그", 'delicious'=>"딜리셔스", 'yahoo_bookmarks'=>"야후", 'youtube'=>"유튜브", 'flicker'=>"플리커");
}


function SNS_icons_config($plugin) {

	SNS_names($sns_name_array, $sns_balloon_name_array, $sns_sidename_array);
	
	$position_array = array("onTop", "onBottom", "onSidebar", "onTag", "account_icons_onSidebar", "account_icons_onTag");
	$position_name_array = array('onTop'=>"글 보내기 - 본문 위", 'onBottom'=>"글 보내기 - 본문 아래", 'onSidebar'=>"글 보내기 - 옆막대", 'onTag'=>"글 보내기 - 치환자 [##_SNS_icons_##]", 'account_icons_onSidebar'=>"계정으로 보내기 - 옆막대", 'account_icons_onTag'=>"계정으로 보내기 - 치환자 [##_SNS_account_icons_##]");
	$position_name_array2 = array('onTop'=>"본문 위", 'onBottom'=>"본문 아래", 'onSidebar'=>"옆막대", 'onTag'=>"치환자", 'account_icons_onSidebar'=>"옆막대", 'account_icons_onTag'=>"치환자");

	$manifest .= '<config dataValHandler = "SNS_icons_DataSet">'.CRLF;

	$manifest .= '	<fieldset legend="단추 꾸미기 (CSS 넣기)">'.CRLF;
	$manifest .= '		<field title="SNS에 글 보내기 :" type="checkbox" name="SNS_icon_css">'.CRLF;
	foreach($position_array as $position) {
		$manifest .= '			<op name="'.$position.'_css" value="1" checked="checked"><![CDATA['.$position_name_array2[$position].']]></op>'.CRLF;
		if($position == "onTag") break;
	}
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		<field title="SNS 계정으로 보내기 :" type="checkbox" name="SNS_account_icons_css">'.CRLF;
	foreach($position_array as $position) {
		if(substr($position,0,2) == "on") continue;
		$manifest .= '			<op name="'.$position.'_css" value="1" checked="checked"><![CDATA['.$position_name_array2[$position].']]></op>'.CRLF;
	}
	$manifest .= '			<caption><![CDATA[';
	$manifest .= '			※ 갈매기표를 하지 않으면 아래의 단추 꾸밈 설정이 전혀 반영되지 않습니다.<br />'.CRLF;
	$manifest .= '			]]></caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '	</fieldset>'.CRLF;

	$manifest .= '	<fieldset legend="SNS에 글 보내기">'.CRLF;
	$manifest .= '		<field title="본문에 넣을 곳 :" type="checkbox" name="positions">'.CRLF;
	$manifest .= '			<op name="onTop" value="1"><![CDATA[본문 위]]></op>'.CRLF;
  $manifest .= '			<op name="onBottom" value="1" checked="checked"><![CDATA[본문 아래]]></op>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		<field title="메타 정보 넣기 :" type="checkbox" name="meta_info">'.CRLF;
	$manifest .= '			<op name="meta_title" value="1"><![CDATA[제목]]></op>'.CRLF;
  $manifest .= '			<op name="meta_description" value="1"><![CDATA[글머리]]></op>'.CRLF;
  $manifest .= '			<op name="image_src" value="1"><![CDATA[첫 그림]]></op>'.CRLF;
 	$manifest .= '			<caption><![CDATA[';
	$manifest .= '			※ HTML에 &lt;meta name="title" content="제목"&gt;과 같은 메타 정보를 넣습니다.<br />'.CRLF;
	$manifest .= '			※ 페이스북, 디그 등에 글 정보를 건네기 위한 항목입니다.'.CRLF;
	$manifest .= '			]]></caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		<field title=": 글머리 길이 (기본값:150)" name="beginning_length" type="text" size="5" value="" titledirection="bk" />'.CRLF;
	$manifest .= '		<field title="연결할 글 주소 :" name="post_url" type="radio">'.CRLF;
	$manifest .= '			<op value="1" checked="checked"><![CDATA[공개 주소]]></op>'.CRLF;
	$manifest .= '			<op value="2"><![CDATA[숫자 주소]]></op>'.CRLF;
	$manifest .= '			<caption><![CDATA[';
	$manifest .= '			※ 숫자 주소를 고르면 문자 주소를 공개하더라도 숫자 주소로 잇습니다.<br />'.CRLF;
	$manifest .= '			※ 방명록, 글 분류, 보관함 등은 이 설정과 관계 없이 원래 주소로 잇습니다.'.CRLF;
	$manifest .= '			]]></caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		<field title="짧은 주소 :" name="short_url" type="radio">'.CRLF;
	$manifest .= '			<op value="none" checked="checked"><![CDATA[쓰지 않음]]></op>'.CRLF;
	$manifest .= '			<op value="j.mp"><![CDATA[j.mp]]></op>'.CRLF;
	$manifest .= '			<op value="is.gd"><![CDATA[is.gd]]></op>'.CRLF;
	$manifest .= '			<op value="v.gd"><![CDATA[v.gd]]></op>'.CRLF;
	$manifest .= '			<op value="to.ly"><![CDATA[to.ly]]></op>'.CRLF;
	$manifest .= '			<op value="dok.do"><![CDATA[dok.do]]></op>'.CRLF;
	$manifest .= '			<op value="goo.gl"><![CDATA[goo.gl]]></op>'.CRLF;
	$manifest .= '			<op value="durl.me"><![CDATA[durl.me]]></op>'.CRLF;
	$manifest .= '			<op value="other"><![CDATA[다른 주소]]></op>'.CRLF;
	$manifest .= '			<caption><![CDATA[※ 짧은 주소는 글짜 수를 제한하는 쪽글에 들어갑니다.]]></caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		<field title="다른 주소 :" name="other_url" type="text" size="25" value="">'.CRLF;
	$manifest .= '			<caption><![CDATA[※ 다른 주소는 블로그 기본 주소만 갈음하고 나머지 글 주소는 그대로 씁니다.<br />※ 다른 도메인 주소를 쓰려면 http://를 붙여야 합니다.]]></caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;	

	$manifest .= '		<field title="트위터 연결 주소 :" name="twitter_link" type="radio">'.CRLF;
	$manifest .= '			<op value="1" checked="checked"><![CDATA[블로그 고유 주소]]></op>'.CRLF;
	$manifest .= '			<op value="2"><![CDATA[트위터 주소(t.co)]]></op>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		<field title="트위터 via 넣기" name="twitter_options" type="checkbox">'.CRLF;
	$manifest .= '			<op name="twitter_via" value="1"></op>'.CRLF;
	$manifest .= '			<caption><![CDATA[※ 트위터 주소(t.co)를 쓸 때는 숫자 글 주소로 연결합니다.<br />※ 트위터 아이디가 들어 있으면 뒤쪽에 \'via @아이디\'를 붙입니다.]]></caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '	</fieldset>'.CRLF;

	$manifest .= '	<fieldset legend="SNS 계정으로 보내기">'.CRLF;
	$manifest .= '		<field title="트위터 : http://twitter.com/" name="twitter_id" type="text" size="25" value=""/>'.CRLF;
	$manifest .= '		<field title="페이스북 : http://www.facebook.com/" name="facebook_id" type="text" size="25" value="" />'.CRLF;
	$manifest .= '		<field title="요즘 : http://yozm.daum.net/" name="yozm_id" type="text" size="25" value="" />'.CRLF;
	$manifest .= '		<field title="미투데이 : http://me2day.net/" name="me2day_id" type="text" size="25" value="" />'.CRLF;
	$manifest .= '		<field title="커넥트 : http://connect.nate.com/" name="connect_id" type="text" size="25" value="" />'.CRLF;
	$manifest .= '		<field title="유튜브 : http://www.youtube.com/" name="youtube_id" type="text" size="25" value="" />'.CRLF;
	$manifest .= '		<field title="플리커 : http://www.flicker.com/photos/" name="flicker_id" type="text" size="25" value="">'.CRLF;
	$manifest .= '			<caption><![CDATA[※ 주소를 넣은 곳만 계정 단추가 달립니다.]]></caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;	
	$manifest .= '	</fieldset>'.CRLF;
	
	$manifest .= '	<fieldset legend="기타 설정">'.CRLF;
	$manifest .= '		<field title="쪽그림 파일 경로 :" name="icon_path" type="text" size="50" value="">'.CRLF;
	$manifest .= '			<caption><![CDATA[※ 쪽그림 파일의 다른 경로를 지정하여 전송량을 분산할 수 있습니다. 비워 두면 /plugins/SNS_icons/images에서 쪽그림을 불러옵니다.]]></caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '	</fieldset>'.CRLF;

	foreach($position_array as $position) {
		$position_name = $position_name_array[$position];
		$manifest .= '	<fieldset legend="'.$position_name.'">'.CRLF;
		if(substr($position,0,2)=="on") {				// 넣을 SNS와 즐겨찾기 고르기(글 보내기 단추)
			$manifest .= '		<field title=" " type="checkbox" name="buttons">'.CRLF;
			foreach($sns_name_array as $sns_name) {					
				if(preg_match("/^(youtube|flicker)$/",$sns_name)) continue;
				$sns_sidename = $sns_balloon_name_array[$sns_name];
				$manifest .= '			<op name="'.$position.'_'.$sns_name.'" value="1" checked="checked"><![CDATA['.$sns_sidename.']]></op>'.CRLF;
 			}
			$manifest .= '		</field>'.CRLF;
		}
		$manifest .= '		<field title="단추 모양 :" name="'.$position.'_type" type="radio">'.CRLF;
		$manifest .= '			<op value="31x31"><![CDATA[31x31 쪽그림]]></op>'.CRLF;
    $manifest .= '		  <op value="24x24" checked="checked"><![CDATA[24x24 쪽그림]]></op>'.CRLF;
		$manifest .= '			<op value="text"><![CDATA[글 단추]]></op>'.CRLF;
		$manifest .= '		</field>'.CRLF;
		$manifest .= '		<field title="가로 정렬 :" name="'.$position.'_align" type="radio">'.CRLF;
		$manifest .= '			<op value="left"><![CDATA[왼쪽]]></op>'.CRLF;
    $manifest .= '	 		<op value="center"><![CDATA[가운데]]></op>'.CRLF;
		$manifest .= '			<op value="right" checked="checked"><![CDATA[오른쪽]]></op>'.CRLF;
		$manifest .= '			<op value="none"><![CDATA[정렬하지 않음]]></op>'.CRLF;
		$manifest .= '		</field>'.CRLF;
		$manifest .= '		<field title="단추 가로 간격 :" name="'.$position.'_icon_interval" type="text" size="4" value="5" />'.CRLF;
		$manifest .= '		<field title="단추 줄 간격 :" name="'.$position.'_icon_line_height" type="text" size="4" value="10" />'.CRLF;
		$manifest .= '		<field title="쪽그림 이름 :" name="'.$position.'_sidename_position" type="radio">'.CRLF;
		$manifest .= '			<op value="none" checked="checked"><![CDATA[넣지 않음]]></op>'.CRLF;
		$manifest .= '			<op value="right"><![CDATA[오른쪽]]></op>'.CRLF;
		$manifest .= '			<op value="bottom"><![CDATA[아래]]></op>'.CRLF;
		$manifest .= '		</field>'.CRLF;
		$manifest .= '		<field title="쪽그림 이름 글꼴 크기 :" name="'.$position.'_sidename_font_size" type="text" size="4" value="11" />'.CRLF;
		$manifest .= '		<field title="쪽그림 이름 글꼴 색 : #" name="'.$position.'_sidename_font_color" type="text" size="7" value="" />'.CRLF;
		$manifest .= '		<field title="쪽그림 이름 가로폭 :" name="'.$position.'_sidename_width" type="text" size="4" value="0" />'.CRLF;
		$manifest .= '		<field title="쪽그림과 이름 간격 :" name="'.$position.'_sidename_margin" type="text" size="4" value="5" />'.CRLF;
		$manifest .= '		<field title=": 위쪽 여백" name="'.$position.'_margin_top" type="text" size="5" value="10" titledirection="bk" />'.CRLF;
		$manifest .= '		<field title=": 아래쪽 여백" name="'.$position.'_margin_bottom" type="text" size="5" value="10" titledirection="bk" />'.CRLF;
		$manifest .= '		<field title=": 왼쪽 여백" name="'.$position.'_margin_left" type="text" size="5" value="0" titledirection="bk" />'.CRLF;
		$manifest .= '		<field title=": 오른쪽 여백" name="'.$position.'_margin_right" type="text" size="5" value="0" titledirection="bk">'.CRLF;
		$manifest .= '			<caption><![CDATA[※ 여백, 간격, 글꼴 크기에 단위(px, pt, mm, ...)를 넣지 않으면 px를 단위로 붙입니다.]]></caption>'.CRLF;
		$manifest .= '		</field>'.CRLF;
		
		if(substr($position,-7,7)=="Sidebar") {
			$manifest .= '		<field title="옆막대 제목 :" name="'.$position.'_heading_title" type="text" size="25" value=""/>'.CRLF;
			$manifest .= '		<field title="옆막대 제목 태그 :" name="'.$position.'_heading_tag" type="radio">'.CRLF;
			$manifest .= '			<op value="h2"><![CDATA[h2]]></op>'.CRLF;
			$manifest .= '			<op value="h3" checked="checked"><![CDATA[h3]]></op>'.CRLF;
			$manifest .= '			<op value="h4"><![CDATA[h4]]></op>'.CRLF;
			$manifest .= '			<caption><![CDATA[※ 옆막대(사이드바)에 들어갈 제목 태그(h2, h3 등)와 제목을 넣습니다. 비워 두면 옆막대에 제목이 들어가지 않습니다.]]></caption>'.CRLF;
			$manifest .= '		</field>'.CRLF;	
		}
		$manifest .= '	</fieldset>'.CRLF;
	}
	$manifest .= '</config>'.CRLF;

	return $manifest;
}


function SNS_icons_DataSet($data){
	$cfg = Setting::fetchConfigVal($data);
	return true;
}

?>